com.lowagie.text

## Class Utilities

- java.lang.Object
- - com.lowagie.text.Utilities

-     public class Utilities
      extends java.lang.Object

  A collection of convenience methods that were present in many different iText classes.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `Utilities()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.Object[][]` | `addToArray(java.lang.Object[][] original, java.lang.Object[] item)` Utility method to extend an array.
    `static boolean` | `checkTrueOrFalse(java.util.Properties attributes, java.lang.String key)` Checks for a true/false value of a key in a Properties object.
    `static java.lang.String` | `convertFromUtf32(int codePoint)` Converts a UTF32 code point value to a String with the corresponding character(s).
    `static int` | `convertToUtf32(char[] text, int idx)` Converts a unicode character in a character array to a UTF 32 code point value.
    `static int` | `convertToUtf32(char highSurrogate, char lowSurrogate)` Returns the code point of a UTF32 character corresponding with a high and a low surrogate value.
    `static int` | `convertToUtf32(java.lang.String text, int idx)` Converts a unicode character in a String to a UTF32 code point value
    `static java.util.Set` | `getKeySet(java.util.Hashtable table)` Gets the keys of a Hashtable
    `static float` | `inchesToMillimeters(float value)` Measurement conversion from inches to millimeters.
    `static float` | `inchesToPoints(float value)` Measurement conversion from inches to points.
    `static boolean` | `isSurrogateHigh(char c)` Check if the value of a character belongs to a certain interval that indicates it's the higher part of a surrogate pair.
    `static boolean` | `isSurrogateLow(char c)` Check if the value of a character belongs to a certain interval that indicates it's the lower part of a surrogate pair.
    `static boolean` | `isSurrogatePair(char[] text, int idx)` Checks if two subsequent characters in a character array are are the higher and the lower character in a surrogate pair (and therefore eligible for conversion to a UTF 32 character).
    `static boolean` | `isSurrogatePair(java.lang.String text, int idx)` Checks if two subsequent characters in a String are are the higher and the lower character in a surrogate pair (and therefore eligible for conversion to a UTF 32 character).
    `static float` | `millimetersToInches(float value)` Measurement conversion from millimeters to inches.
    `static float` | `millimetersToPoints(float value)` Measurement conversion from millimeters to points.
    `static float` | `pointsToInches(float value)` Measurement conversion from points to inches.
    `static float` | `pointsToMillimeters(float value)` Measurement conversion from points to millimeters.
    `static void` | `skip(java.io.InputStream is, int size)` This method is an alternative for the `InputStream.skip()` -method that doesn't seem to work properly for big values of `size` .
    `static java.net.URL` | `toURL(java.lang.String filename)` This method makes a valid URL from a given filename.
    `static java.lang.String` | `unEscapeURL(java.lang.String src)` Unescapes an URL.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### Utilities

          public Utilities()

  - ### Method Detail

    - #### getKeySet

          public static java.util.Set getKeySet(java.util.Hashtable table)

      Gets the keys of a Hashtable
      Parameters:
        `table` - a Hashtable
      Returns:
        the keyset of a Hashtable (or an empty set if table is null)

    - #### addToArray

          public static java.lang.Object[][] addToArray(java.lang.Object[][] original,
                                        java.lang.Object[] item)

      Utility method to extend an array.
      Parameters:
        `original` - the original array or `null`
        `item` - the item to be added to the array
      Returns:
        a new array with the item appended

    - #### checkTrueOrFalse

          public static boolean checkTrueOrFalse(java.util.Properties attributes,
                                 java.lang.String key)

      Checks for a true/false value of a key in a Properties object.
      Parameters:
        `attributes` -
        `key` -
      Returns:
        a true/false value of a key in a Properties object

    - #### unEscapeURL

          public static java.lang.String unEscapeURL(java.lang.String src)

      Unescapes an URL. All the "%xx" are replaced by the 'xx' hex char value.
      Parameters:
        `src` - the url to unescape
      Returns:
        the unescaped value

    - #### toURL

          public static java.net.URL toURL(java.lang.String filename)
                                    throws java.net.MalformedURLException

      This method makes a valid URL from a given filename.

      This method makes the conversion of this library from the JAVA 2 platform to a JDK1.1.x-version easier.

      Parameters:
        `filename` - a given filename
      Returns:
        a valid URL
      Throws:
        `java.net.MalformedURLException`

    - #### skip

          public static void skip(java.io.InputStream is,
                  int size)
                           throws java.io.IOException

      This method is an alternative for the `InputStream.skip()` -method that doesn't seem to work properly for big values of `size` .
      Parameters:
        `is` - the `InputStream`
        `size` - the number of bytes to skip
      Throws:
        `java.io.IOException`

    - #### millimetersToPoints

          public static final float millimetersToPoints(float value)

      Measurement conversion from millimeters to points.
      Parameters:
        `value` - a value in millimeters
      Returns:
        a value in points
      Since:
        2.1.2

    - #### millimetersToInches

          public static final float millimetersToInches(float value)

      Measurement conversion from millimeters to inches.
      Parameters:
        `value` - a value in millimeters
      Returns:
        a value in inches
      Since:
        2.1.2

    - #### pointsToMillimeters

          public static final float pointsToMillimeters(float value)

      Measurement conversion from points to millimeters.
      Parameters:
        `value` - a value in points
      Returns:
        a value in millimeters
      Since:
        2.1.2

    - #### pointsToInches

          public static final float pointsToInches(float value)

      Measurement conversion from points to inches.
      Parameters:
        `value` - a value in points
      Returns:
        a value in inches
      Since:
        2.1.2

    - #### inchesToMillimeters

          public static final float inchesToMillimeters(float value)

      Measurement conversion from inches to millimeters.
      Parameters:
        `value` - a value in inches
      Returns:
        a value in millimeters
      Since:
        2.1.2

    - #### inchesToPoints

          public static final float inchesToPoints(float value)

      Measurement conversion from inches to points.
      Parameters:
        `value` - a value in inches
      Returns:
        a value in points
      Since:
        2.1.2

    - #### isSurrogateHigh

          public static boolean isSurrogateHigh(char c)

      Check if the value of a character belongs to a certain interval that indicates it's the higher part of a surrogate pair.
      Parameters:
        `c` - the character
      Returns:
        true if the character belongs to the interval
      Since:
        2.1.2

    - #### isSurrogateLow

          public static boolean isSurrogateLow(char c)

      Check if the value of a character belongs to a certain interval that indicates it's the lower part of a surrogate pair.
      Parameters:
        `c` - the character
      Returns:
        true if the character belongs to the interval
      Since:
        2.1.2

    - #### isSurrogatePair

          public static boolean isSurrogatePair(java.lang.String text,
                                int idx)

      Checks if two subsequent characters in a String are are the higher and the lower character in a surrogate pair (and therefore eligible for conversion to a UTF 32 character).
      Parameters:
        `text` - the String with the high and low surrogate characters
        `idx` - the index of the 'high' character in the pair
      Returns:
        true if the characters are surrogate pairs
      Since:
        2.1.2

    - #### isSurrogatePair

          public static boolean isSurrogatePair(char[] text,
                                int idx)

      Checks if two subsequent characters in a character array are are the higher and the lower character in a surrogate pair (and therefore eligible for conversion to a UTF 32 character).
      Parameters:
        `text` - the character array with the high and low surrogate characters
        `idx` - the index of the 'high' character in the pair
      Returns:
        true if the characters are surrogate pairs
      Since:
        2.1.2

    - #### convertToUtf32

          public static int convertToUtf32(char highSurrogate,
                           char lowSurrogate)

      Returns the code point of a UTF32 character corresponding with a high and a low surrogate value.
      Parameters:
        `highSurrogate` - the high surrogate value
        `lowSurrogate` - the low surrogate value
      Returns:
        a code point value
      Since:
        2.1.2

    - #### convertToUtf32

          public static int convertToUtf32(char[] text,
                           int idx)

      Converts a unicode character in a character array to a UTF 32 code point value.
      Parameters:
        `text` - a character array that has the unicode character(s)
        `idx` - the index of the 'high' character
      Returns:
        the code point value
      Since:
        2.1.2

    - #### convertToUtf32

          public static int convertToUtf32(java.lang.String text,
                           int idx)

      Converts a unicode character in a String to a UTF32 code point value
      Parameters:
        `text` - a String that has the unicode character(s)
        `idx` - the index of the 'high' character
      Returns:
        the codepoint value
      Since:
        2.1.2

    - #### convertFromUtf32

          public static java.lang.String convertFromUtf32(int codePoint)

      Converts a UTF32 code point value to a String with the corresponding character(s).
      Parameters:
        `codePoint` - a Unicode value
      Returns:
        the corresponding characters in a String
      Since:
        2.1.2